/*
 * Copyright 2017-2020, Schlumberger
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.opengroup.osdu.register.swagger;

public final class SwaggerDoc {
    /*
     * Action
     */
    public static final String ACTION_TAG = "Action Register";
    public static final String ACTION_DESCRIPTION = "Action management";
    public static final String DATA_PARTITION_DESCRIPTION = "Specifies the tenant to use. This should be either the partition name or crm account ID associated with the partition.";

    // CREATE ACTION
    public static final String CREATE_ACTION = "Create Action";
    public static final String CREATE_ACTION_DESCRIPTION = "The API allows the creation of a new action. Required roles: 'users.datalake.editors' or 'users.datalake.ops' or 'users.datalake.admins'.";
    public static final String CREATE_ACTION_RESPONSE_CREATED = "Action created successfully.";

    // RETRIEVE ACTION
    public static final String RETRIEVE_ACTION = "Retrieve Action";
    public static final String RETRIEVE_ACTION_DESCRIPTION = "The API retrieves actions that have a matching filter to the record in the request, template values in the action will be substituted from the record. Required roles: 'users.datalake.viewers' or 'users.datalake.editors' or 'users.datalake.ops' or 'users.datalake.admins'.";
    public static final String RETRIEVE_ACTION_RESPONSE_OK = "Actions retrieved successfully.";

    // DELETE ACTION
    public static final String DELETE_ACTION = "Delete Action";
    public static final String DELETE_ACTION_DESCRIPTION = "The API deletes the action of the given Id. Required roles: 'users.datalake.ops' or 'users.datalake.admins'.";
    public static final String DELETE_ACTION_RESPONSE_NO_CONTENT ="Action deleted successfully.";

    // GET ACTION
    public static final String GET_ACTION = "Get Action";
    public static final String GET_ACTION_DESCRIPTION = "The API gets the action of the given id. Required roles: 'users.datalake.viewers' or 'users.datalake.editors' or 'users.datalake.ops' or 'users.datalake.admins'.";
    public static final String GET_ACTION_RESPONSE_OK = "Get the action successfully.";

    // TEST ACTION
    public static final String TEST_ACTION = "Test Action";
    public static final String TEST_ACTION_DESCRIPTION = "The API takes the action and a test payload, then return whether the action would match the filter and if there are any errors extracting a regex value. Required roles: 'users.datalake.viewers' or 'users.datalake.editors' or 'users.datalake.ops' or 'users.datalake.admins'.";
    public static final String TEST_ACTION_RESPONSE_OK = "The regex is validated and works as expected.";

    private SwaggerDoc() {
        // private constructor
    }
}
